﻿Public Class HSet(Of T)
    Inherits HashSet(Of T)

    ' Constructors.
    Public Sub New()
        MyBase.New()
    End Sub
    Public Sub New(ByVal comparer As IEqualityComparer(Of T))
        MyBase.New(comparer)
    End Sub
    Public Sub New(ByVal collection As IEnumerable(Of T))
        MyBase.New(collection)
    End Sub
    Public Sub New(ByVal collection As IEnumerable(Of T), ByVal comparer As IEqualityComparer(Of T))
        MyBase.New(collection, comparer)
    End Sub
    Public Sub New(ByVal info As System.Runtime.Serialization.SerializationInfo, ByVal context As System.Runtime.Serialization.StreamingContext)
        MyBase.New(info, context)
    End Sub

    ' Union.
    Public Shared Operator Or(ByVal A As HSet(Of T), ByVal B As HSet(Of T)) As HSet(Of T)
        Dim result As New HSet(Of T)(A)
        result.UnionWith(B)
        Return result
    End Operator

    ' Intersection.
    Public Shared Operator And(ByVal A As HSet(Of T), ByVal B As HSet(Of T)) As HSet(Of T)
        Dim result As New HSet(Of T)(A)
        result.IntersectWith(B)
        Return result
    End Operator

    ' Xor.
    Public Shared Operator Xor(ByVal A As HSet(Of T), ByVal B As HSet(Of T)) As HSet(Of T)
        Dim result As New HSet(Of T)(A)
        result.SymmetricExceptWith(B)
        Return result
    End Operator

    ' Subset.
    Public Shared Operator <(ByVal A As HSet(Of T), ByVal B As HSet(Of T)) As Boolean
        Return A.IsSubsetOf(B)
    End Operator

    ' Superset.
    Public Shared Operator >(ByVal A As HSet(Of T), ByVal B As HSet(Of T)) As Boolean
        Return A.IsSupersetOf(B)
    End Operator

    ' Contains element.
    Public Shared Operator >(ByVal A As HSet(Of T), ByVal element As T) As Boolean
        Return A.Contains(element)
    End Operator

    ' Consists of a single element.
    Public Shared Operator <(ByVal A As HSet(Of T), ByVal element As T) As Boolean
        Return (A > element) AndAlso (A.Count = 1)
    End Operator
End Class
